/*
 * LoginAction.java
 *
 * Created on April 12, 2007, 7:22 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.myapp.struts;

import org.apache.struts.config.*;
import org.apache.struts.action.*;
import javax.servlet.http.*;
import javax.servlet.*;
import com.zeevbelkin.web.filter.access.*;
/**
 *
 * @author zeev
 */
public class LoginAction extends Action {
    
    public ActionForward execute(
            ActionMapping mapping,
            ActionForm form,
            HttpServletRequest request,
            HttpServletResponse response
            ) throws Exception {
        DynaActionForm dac=(DynaActionForm)form;
        Yaaf.SessionSecurityInfo ssi=(Yaaf.SessionSecurityInfo)request.getUserPrincipal();
        
        synchronized (ssi.getLock()) {
            
            if (ssi.getName()!=null)
               return mapping.findForward("alreadyLoggedIn");

            if (!ssi.isSavedRequestValid(request))
               return mapping.findForward("outdatedLoginSequence");
            
            if ("pupkin".equals(dac.getString("login"))&&"stam".equals(dac.getString("password"))) {
                // Yes, this guy is really Pupkin ...
                
                ssi.setName("pupkin");
                
                // Remember the user
                // to allow to him/her to log in
                // w/o any explicite action
                
                ssi.saveLogin(request,response,365);

                if (ssi.isExplicitLogin()) {
                    return mapping.findForward("afterExplicitLogin");
                } else
                    ssi.completeLogin(request,response);
                
                return null;
            }
            // failure
            request.setAttribute("failure","failure");
            return mapping.findForward("loginScreen");
        }
    }
    
}
